"""Confusion Matrix Generator

    * Author:  José Luis Pérez Martínez
    * Company: Universitat Politècnica de València
    * Date:    25/02/2022

This script generates a Confusion Matrix for the validation results
provided by YOLOv5 for Polenet datasets.

This scripts requires `numpy` to be installed within the environment
you are running this script in.

It also requires the `utils` module provided with the repository
located in the same directory.

The program expects the JSON file to be the one generated with the
validation tool `val.py` of YOLOv5 when used the flag `--save-json`:

$ python val.py --data polenet.yaml --weights polenet.pt --save-json

This file can also be imported asa module and contains the following
functions:

    * loadGroundTruth - loads the ground truth from the dataset
    * loadPredictions - loads the predictions of the model
    * genConfMat - generates the confusion matrix
    * main - the main function of the script
"""

import os, sys
import numpy as np
import json
import argparse
import xml.etree.ElementTree as ET

import utils


def loadGroundTruth(xml_list, classes=None):
    """Loads the ground truth from the dataset
    
    Parameters
    ----------
    xml_list : list
        The list of XML files that compose the dataset.
    classes : list, optional
        List of IDs of the classes to be included in the model, either
        for training, validation or detection. If no classes are
        specified, the model will include all the classes found in the
        dataset.
    
    Return
    ------
    gt : list
        List with the ground truth of the labelled classes. Each
        element is a tuple composed of the class IDs and its bounding
        box.
    pollen_collection : dict
        Dictionary of class ids (key) and class names (value) found at
        the dataset
    """
    
    cwd = os.getcwd()
    img_dir = os.path.join(cwd, 'Tests')
    
    gt = dict()
    pollen_collection = dict()
    
    class_map = dict()
    if classes:
        for i, v in enumerate(sorted(classes)):
            class_map[v] = i

    trees = list()
    for xml in xml_list:
        trees.append(ET.parse(xml))
    
    for t in trees:
        for slide in t.getroot().iter('microscopeSlides'):
            for honey in slide.iter('honeyImages'):
                img = honey.find('imageName').text[:-4]
                gt_class_id = list()
                gt_bbox = list()
                for pollen in honey.iter('pollenSamples'):
                    pollen_id = int(pollen.find('pollenID').text)
                    if classes:
                        if pollen_id in classes:
                            pollen_name = pollen.find('pollenName').text
                            pollen_collection[pollen_id] = pollen_name.strip()
                            pollen_x = float(pollen.find('X').text)
                            pollen_y = float(pollen.find('Y').text)
                            pollen_size = float(pollen.find('pollenSize').text)
                            x_min = pollen_x - (pollen_size/2)
                            y_min = pollen_y - (pollen_size/2)
                            x_max = pollen_x + (pollen_size/2)
                            y_max = pollen_y + (pollen_size/2)
                            gt_class_id.append(class_map[pollen_id])
                            gt_bbox.append([x_min, y_min, x_max, y_max])
                    else:
                        pollen_name = pollen.find('pollenName').text
                        pollen_collection[pollen_id] = pollen_name.strip()
                        pollen_x = float(pollen.find('X').text)
                        pollen_y = float(pollen.find('Y').text)
                        pollen_size = float(pollen.find('pollenSize').text)
                        x_min = pollen_x - (pollen_size/2)
                        y_min = pollen_y - (pollen_size/2)
                        x_max = pollen_x + (pollen_size/2)
                        y_max = pollen_y + (pollen_size/2)
                        gt_class_id.append(pollen_id)
                        gt_bbox.append([x_min, y_min, x_max, y_max])
                if len(gt_class_id) > 0:
                    gt[img] = (gt_class_id, gt_bbox)

    return gt, pollen_collection


def loadPredictions(json_file, score=0):
    """Loads the ground truth from the dataset
    
    Parameters
    ----------
    json_file : str
        Path and name of the json file with the prediction generated by
        YOLOv5
    score : float, optional
        Threshold score for taking a prediction as valid. `score` has
        to be in the range [0, 1], where 0 means that all detections
        are valid and 1 means that none of them are. Default is 0.
    
    Returns
    -------
    list
        List with the predictions of the model. Each element is a tuple
        composed of the class IDs and its bounding box.
    """
    
    pred = dict()
    
    with open(json_file) as f:
        load_pred = json.load(f)
    
    for p in load_pred:
        if p['score'] > score:
            pred_class_id, pred_bbox = pred.get(p['image_id'], (list(), list()))
            pred_class_id.append(p['category_id'])
            x_min = p['bbox'][0]
            y_min = p['bbox'][1]
            x_max = p['bbox'][0] + p['bbox'][2]
            y_max = p['bbox'][1] + p['bbox'][3]
            pred_bbox.append([x_min, y_min, x_max, y_max])
            pred[p['image_id']] = (pred_class_id, pred_bbox)
    
    return pred


def genConfMat(xml_list, json_file, val_file, classes=None, save_path=None, score=0.5):
    """Generates the confusion matrix from the validation of the model
    
    Parameters
    ----------
    xml_list : list
        The list of XML files that compose the dataset.
    json_file : str
        Path and name of the json file with the prediction generated by
        YOLOv5
    classes : list, optional
        List of IDs of the classes to be included in the model, either
        for training, validation or detection. If no classes are
        specified, the model will include all the classes found in the
        dataset.
    save_path : str, optional
        Directory where the generated confusion matrix is saved. If no
        `save_path` is provided, the confusion matrix will only be
        diplayed.
    score : float [0, 1]
        Threshold score to accept identifications as objects.
    
    Returns
    -------
    """
    
    load_gt, pollen_collection = loadGroundTruth(xml_list, classes)
    load_pred = loadPredictions(json_file, score=score)
    
    val_images = list()
    with open(val_file) as f:
        for line in f:
            image_name = '.'.join(os.path.basename(line).split('.')[:-1])
            val_images.append(image_name)
    
    gt_tot = np.array([])
    pred_tot = np.array([])
    
    for im in val_images:
        gt_class_id = np.array(list(map(lambda x: x+1, load_gt[im][0])))
        gt_bbox = np.array(load_gt[im][1])
        
        if im in load_pred.keys():
            pred_class_id = np.array(list(map(lambda x: x+1, load_pred[im][0])))
            pred_bbox = np.array(load_pred[im][1])
        else:
            pred_class_id = np.array(list())
            pred_bbox = np.array(list())
        
        gt, pred = utils.gt_pred_lists(gt_class_id, gt_bbox, pred_class_id, pred_bbox)
        
        #print(im)
        #print(gt)
        #print(pred)
        
        gt_tot = np.append(gt_tot, gt)
        pred_tot = np.append(pred_tot, pred)
    
    names = list()
    if classes:
        for c in sorted(list(set(classes))):
            if c > 0:
                names.append(pollen_collection.get(c, 'Class_{}'.format(c)))
    else:
        for c in sorted(list(set(gt_tot))):
            if c > 0:
                names.append(pollen_collection.get(c-1, 'Class_{}'.format(c-1)))
    
    tp,fp,fn=utils.plot_confusion_matrix_from_data(gt_tot,pred_tot,fz=18, figsize=(20,20), lw=0.5, columns=['Background']+names, save_path=save_path)
    
    print('####################')
    print('True Positives: ', sum(tp))
    print('False Positives:', sum(fp[1:]))
    print('False Negatives:', sum(fn[1:]))
    print('####################')


def main(args):
    """Main function of the script
    
    Parameters
    ----------
    args : list
        List of input parameters and flags
    
    Returns
    -------
    """
    
    parser = argparse.ArgumentParser(
    description=__doc__,
    formatter_class=argparse.RawTextHelpFormatter)
    
    parser.add_argument(
        '-d', '--datasets',
        metavar='XML',
        nargs='+',
        required=True,
        help='One or more XML files with the description of a Polenet dataset.')
    parser.add_argument(
        '-v', '--validation-file',
        metavar='VAL',
        required=True,
        help='File with the list of images used for validation.')
    parser.add_argument(
        '-r', '--results',
        metavar='JSON',
        required=True,
        help='The JSON file generated by YOLOv5 validation (val.py) with flag --save-json for Polenet dataset.')
    parser.add_argument(
        '-o', '--output',
        metavar='PATH',
        default=None,
        help='Directory where save the confusion matrix. If not provided, the confusion matrix will only be displayed.')
    parser.add_argument(
        '-C', '--classes',
        metavar='CLASS',
        nargs='+',
        type=int,
        help='Polenet classes (ID) used in the model.')
    parser.add_argument(
        '-s', '--score',
        metavar='SCORE',
        default=0.5,
        type=float,
        help='Threshold score to accept identifications as objects. By default is set to 0.5.')
    
    args = parser.parse_args()
    
    dataset_list = list()
    for d in args.datasets:
        if d.endswith('.xml'):
            dataset_list.append(d)
        elif d.endswith('.txt'):
            with open(d) as f:
                for line in f:
                    line = line.strip()
                    if line.endswith('.xml'):
                        file_path = os.path.dirname(d)
                        dataset_list.append(os.path.join(file_path, line.strip()))

    genConfMat(dataset_list, args.results, args.validation_file, classes=args.classes, save_path=os.path.join(args.output, 'conf_mat.png') if args.output else None, score=args.score)


if __name__ == '__main__':
    main(sys.argv[1:])
        
